#!/usr/bin/env bash

_alarm() {
  ( \speaker-test --frequency $1 --test sine )&
  pid=$!
  \sleep 0.${2}s
  \kill -9 $pid
}

getnproc="$(nproc)"
getgdpid="$(pidof 'Grim Dawn.exe')"
getgipid="$(pidof 'GrimInternals64')"

if pgrep "Grim Dawn" > /dev/null 2>&1; then
    case "$getnproc" in
        4)  echo 4 threads found
            sleep 1  
            taskset -pac 1,2,3 "${getgdpid}" &&
            _alarm 400 200
            echo 'waiting 8 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 7 seconds' 
            sleep 1
            echo -e '\e[1A\e[Kwaiting 6 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 5 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 4 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 3 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 2 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 1 seconds' 
            
            taskset -pac 0,1,2,3 "${getgdpid}" &&
            _alarm 400 200
            echo "core affinity set!";;
        6)  echo 6 threads found
            sleep 1  
            taskset -pac 1,2,3,4,5 "${getgdpid}" &&
            _alarm 400 200
            echo 'waiting 8 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 7 seconds' 
            sleep 1
            echo -e '\e[1A\e[Kwaiting 6 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 5 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 4 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 3 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 2 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 1 seconds' 
            sleep 1
            taskset -pac 0,1,2,3,4,5 "${getgdpid}" &&
            _alarm 400 200
            echo "core affinity set!";;
        8)  echo 8 threads found
            sleep 1  
            taskset -pac 1,2,3,4,5,6,7 "${getgdpid}" &&
            _alarm 400 200
            echo 'waiting 8 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 7 seconds' 
            sleep 1
            echo -e '\e[1A\e[Kwaiting 6 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 5 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 4 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 3 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 2 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 1 seconds' 
            sleep 1
            taskset -pac 0,1,2,3,4,5,6,7 "${getgdpid}" &&
            _alarm 400 200
            echo "core affinity set!";;
        *)  echo "Your amount of cpu-threads isn't compatible with this script";;
    esac
elif pgrep "GrimInternals64" > /dev/null 2>&1; then
    case "$getnproc" in
        4)  echo 4 threads found
            sleep 1  
            taskset -pac 1,2,3 "${getgipid}" &&
            _alarm 400 200
            echo 'waiting 8 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 7 seconds' 
            sleep 1
            echo -e '\e[1A\e[Kwaiting 6 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 5 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 4 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 3 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 2 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 1 seconds' 
            
            taskset -pac 0,1,2,3 "${getgipid}" &&
            _alarm 400 200
            echo "core affinity set!";;
        6)  echo 6 threads found
            sleep 1  
            taskset -pac 1,2,3,4,5 "${getgipid}" &&
            _alarm 400 200
            echo 'waiting 8 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 7 seconds' 
            sleep 1
            echo -e '\e[1A\e[Kwaiting 6 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 5 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 4 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 3 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 2 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 1 seconds' 
            sleep 1
            taskset -pac 0,1,2,3,4,5 "${getgipid}" &&
            _alarm 400 200
            echo "core affinity set!";;
        8)  echo 8 threads found
            sleep 1  
            taskset -pac 1,2,3,4,5,6,7 "${getgipid}" &&
            _alarm 400 200
            echo 'waiting 8 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 7 seconds' 
            sleep 1
            echo -e '\e[1A\e[Kwaiting 6 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 5 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 4 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 3 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 2 seconds'
            sleep 1
            echo -e '\e[1A\e[Kwaiting 1 seconds' 
            sleep 1
            taskset -pac 0,1,2,3,4,5,6,7 "${getgipid}" &&
            _alarm 400 200
            echo "core affinity set!";;
        *)  echo "Your amount of cpu-threads isn't compatible with this script";;
    esac
fi
